/*
 * scanner.h
 *
 * Created: 2014-04-04 14:37:30
 *  Author: dsosnowski
 */ 


#ifndef SCANNER_H_
#define SCANNER_H_

#define SCAN_BUFF_SIZE		64
#define SCAN_MAX_CELL		1
#define SCAN_BUFF_MIN		1
#define SCAN_PULSE_MIN		3
#define SCAN_PULSE_MAX		250
#define SCAN_PULSE_TOLERANCE		4

//---------------------------------------
#define SCAN_IDLE			0
#define SCAN_FIND			1
#define SCAN_START			2
#define SCAN_PROCESS		3
#define SCAN_COMPLETE		4
#define SCAN_ERROR			5




#define PRESCALER_RESET		GTCCR |= (1<<PSR10)

#define TIMER_START			TCCR0B = (1<<CS02)
//div 256, 80000000/256 = 0,000 032s per tick
//cycle = 0,0082 s

//div 256, 11059200/256 = 0,000 023s per tick
//cycle = 0,0059 s
			
//#define TIMER_START			TCCR0B = (1<<CS01 | 1<<CS00)
//div 64, 8000000/64 = 0,000 008s per tick
//cycle = 0,00204 s

//#define TIMER_START			TCCR0B = (1<<CS02 | 1<<CS00)
//div 1024, 8000000/1024 = 0,000 128s per tick
//cycle = 0,032 s


#define TIMER_STOP			TCCR0B = 0
#define TIMER_RESET			TCNT0 = 0
#define TIMER_ENABLE		TIMSK0 |= (1<<TOIE0)
#define TIMER_DISABLE		TIMSK0 &=~(1<<TOIE0)
#define TIMER_CLEAR			TIFR0  |= (1<<TOV0)
#define TIMER_VALUE			TCNT0


//config interrupts
#define PCINT_CONFIG		PCMSK0 |= (1<<PCINT5)			//any level
#define PCINT_ENABLE		GIMSK  |= (1<<PCIE0)
#define PCINT_DISABLE		GIMSK  &=~(1<<PCIE0)
#define PCINT_CLEAR			GIFR  |= (1<<PCIF0)


void ScannerInit (void);
void ScannerStart (void);
void ScannerStop(void);
char ScannerCheck(char action);
void ScannerSave(char cell);
void ScannerLoad(char cell);
char ScannerComp(void);


#endif /* SCANNER_H_ */